
#include <stdio.h>
#include <stdlib.h>

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

static void	Print(int cg,int scan,int cc)
{
	cudaDeviceProp	dp;

	if (cudaGetDeviceProperties(&dp,cg)!=cudaSuccess)
	    Error("error in cudaGetDeviceProperties().");

	if (dp.major<1) 
	    if (scan)
		return;
	    else
		Error("device not supported by CUDA.");

	if (scan) (void)printf("%d\t",cg);

	if (cc) (void)printf("%d\t%d\t",dp.major,dp.minor);

	(void)puts(dp.name);
}

int	main(int argc,char **argv)
{
	char	*str;
	int	cc,dc,cg;

	for (str=argv[0]; *str!='\0'; str++) ;

	if (str[-4]=='.' && (str[-3]|0x20)=='e'
			 && (str[-2]|0x20)=='x'
			 && (str[-1]|0x20)=='e') str-=4;

	cc=str[-3]=='_' && (str[-2]|0x20)=='c' && (str[-1]|0x20)=='c';

	if (cudaGetDeviceCount(&dc)!=cudaSuccess)
	    Error("error in cudaGetDeviceCount().");

	if (argc==1)
	    if ((str=getenv("CUDA_GPU"))==NULL)
		for (cg=0; cg<dc; cg++) Print(cg,1,cc);
	    else {
		if (sscanf(str,"%d",&cg)!=1 || cg<0 || cg>=dc)
		    Error("no device assigned by CUDA_GPU.");

		Print(cg,0,cc);
	    }
	else
	    while (--argc>0) {
		if (sscanf(*(++argv),"%d",&cg)!=1 || cg<0 || cg>=dc)
		    Error("bad device number.");

		Print(cg,0,cc);
	    }

	return 0;
}
